
unit CELLS;
INTERFACE

uses GRAPH;
type
    Cell = object
    private
        x,y: byte;
    public
        function GetX: byte;
        procedure SetX(x0: byte);
        function GetY: byte;
        procedure SetY(y0: byte);
    end;
    Empty = object(Cell)
    private        
    public
        procedure Draw;
    end;
    Player = object(Cell)
    private
    public
        procedure Draw;
    end;
    Block = object(Cell)
    private
    public
        procedure Draw;
    end;
    Goal = object(Cell)
    private
    public
        procedure Draw;
    end;
    BlockX = object(Cell)
    private
    public
        procedure Draw;
    end;
    PlayerX = object(Cell)
    private
    public
        procedure Draw;
    end;
    Wall = object(Cell)
    private
    public
        procedure Draw;
    end;


IMPLEMENTATION


{ Cell -------------------- }

function Cell.GetX;
begin
    GetX:= x;
end;

procedure Cell.SetX;
begin
    x:= x0;
end;

function Cell.GetY;
begin
    GetY:= y;
end;

procedure Cell.SetY;
begin
    y:= y0;
end;

{ Draw ------------------- }

procedure Empty.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
end;

procedure Wall.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, Green);
    Bar(0, 0, 29, 29);
end;

procedure Player.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
    SetColor(Black);
    Line(1, 4, 4, 1);
    Line(1, 5, 5, 1);
    Line(1, 6, 6, 1);
    Line(2, 6, 6, 2);
    Line(23, 2, 27, 6);
    Line(23, 1, 28, 6);
    Line(24, 1, 28, 5);
    Line(25, 1, 28, 4);
    Line(27, 23, 23, 27);
    Line(28, 23, 23, 28);
    Line(28, 24, 24, 28);
    Line(28, 25, 25, 28);
    Line(2, 23, 6, 27);
    Line(1, 23, 6, 28);
    Line(1, 24, 5, 28);
    Line(1, 25, 4, 28);
    SetFillStyle(1, Red);
    Bar(3, 3, 26, 26);
    SetFillStyle(1, LightRed);
    Bar(6, 6, 23, 23);
    SetFillStyle(1, Red);
    Bar(15, 8, 20, 13);
    SetFillStyle(1, Yellow);
    Bar(16, 9, 19, 12);
end;

procedure Block.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
    SetFillStyle(1, Cyan);
    Bar(3, 3, 26, 26);
    SetFillStyle(1, LightCyan);
    Bar(6, 6, 23, 23);
    SetColor(Cyan);
    Line(6, 23, 23, 6);
    Line(6, 22, 22, 6);
    Line(7, 23, 23, 7);
    Line(3, 3, 26, 26);
    Line(3, 4, 25, 26);
    Line(4, 3, 26, 25);
end;

procedure Goal.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
    SetFillStyle(1, Green);
    Bar(6, 6, 23, 23);
    SetFillStyle(1, LightGreen);
    Bar(7, 7, 22, 22);
    SetFillStyle(1, Green);
    Bar(11, 11, 18, 18);
    SetFillStyle(1, LightGreen);
    Bar(12, 12, 17, 17);
end;

procedure BlockX.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
    SetFillStyle(1, Cyan);
    Bar(3, 3, 26, 26);
    SetFillStyle(1, LightCyan);
    Bar(6, 6, 23, 23);
    SetColor(Cyan);
    Line(6, 23, 23, 6);
    Line(6, 22, 22, 6);
    Line(7, 23, 23, 7);
    Line(3, 3, 26, 26);
    Line(3, 4, 25, 26);
    Line(4, 3, 26, 25);
    SetFillStyle(1, Red);
    Bar(5, 8, 17, 12);
    SetFillStyle(1, LightRed);
    Bar(6, 9, 16, 11);
end;

procedure PlayerX.Draw;
begin
    SetViewPort(GetX*30, GetY*30, (GetX+1)*30-1, (GetY+1)*30-1, true);
    SetFillStyle(1, LightGreen);
    Bar(0, 0, 29, 29);
    SetFillStyle(1, Green);
    Bar(1, 1, 28, 28);
    SetFillStyle(1, LightGreen);
    Bar(2, 2, 27, 27);
    SetColor(Black);
    Line(1, 4, 4, 1);
    Line(1, 5, 5, 1);
    Line(1, 6, 6, 1);
    Line(2, 6, 6, 2);
    Line(23, 2, 27, 6);
    Line(23, 1, 28, 6);
    Line(24, 1, 28, 5);
    Line(25, 1, 28, 4);
    Line(27, 23, 23, 27);
    Line(28, 23, 23, 28);
    Line(28, 24, 24, 28);
    Line(28, 25, 25, 28);
    Line(2, 23, 6, 27);
    Line(1, 23, 6, 28);
    Line(1, 24, 5, 28);
    Line(1, 25, 4, 28);
    SetFillStyle(1, Red);
    Bar(3, 3, 26, 26);
    SetFillStyle(1, LightRed);
    Bar(6, 6, 23, 23);
    SetFillStyle(1, Red);
    Bar(15, 8, 20, 13);
    SetFillStyle(1, Yellow);
    Bar(16, 9, 19, 12);
end;

end.
