unit MENU;
INTERFACE

uses CRT, GRAPH, GAME;
procedure Welcome;
procedure StartMenu;
procedure OpenLvl(chosen0: byte); 
procedure DrawBackground;
procedure DrawCentr(numb: byte);
procedure HideCentr;
procedure DrawLeftPart(numb: byte);
procedure HideLeftPart;
procedure DrawRightPart(numb: byte);
procedure HideRightPart;
procedure MenuLeft(var num: byte);
procedure MenuRight(var num: byte);
procedure GameExit;
procedure Fail;
IMPLEMENTATION



procedure StartMenu;
var
    chosen: byte;
    ch: char;
begin
    chosen:= 1;
    DrawBackground;
    DrawCentr(chosen);
    DrawRightPart(chosen+1);
    repeat
        if KeyPressed then
        begin
            ch:= ReadKey;
            case ch of
            #75: MenuLeft(chosen);
            #77: MenuRight(chosen);
            #13: OpenLvl(chosen);
            #27: GameExit;
            end;
        end;
        Delay(1);
    until false;
end;

procedure OpenLvl;
begin
    OpenLevel(chosen0);
    StartMenu;
end;

procedure DrawBackground;
var
    a,b: byte;
    n: string;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    n:= 'SOCOBAN';
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, Green);
    Bar(0, 0, GetMaxX, GetMaxY);
    SetTextStyle(0, 0, 2);
    SetColor(LightGreen);
    OutTextXY(Trunc((GetMaxX-TextWidth(n))/2), GetMaxY-5-TextHeight(n), n);
    SetFillStyle(1, LightGreen);
    Bar(30, 30, GetMaxX-30, GetMaxY-30);
    SetViewPort(a*4-8, b*2-8, a*8+8, b*8+8, true);
    SetFillStyle(1, Yellow);
    Bar(0, 0, 4*a+16, 6*b+16);
    SetFillStyle(1, LightRed);
    Bar(8, 8, 4*a+8, 6*b+8);
end;

procedure DrawCentr;
var
    n: string;
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    Str(numb, n);
    SetViewPort(0, 0, GetMaxX, GetMaxY, True);
    SetTextStyle(0, 0, 10);
    SetColor(Red);
    OutTextXY(Trunc(6*a-TextWidth(n)/2), Trunc(5*b-TextHeight(n)/2), n);
end;

procedure HideCentr;
var
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(a*4-8, b*2-8, a*8+8, b*8+8, true);
    SetFillStyle(1, LightRed);
    Bar(8, 8, 4*a+8, 6*b+8);
end;

procedure DrawLeftPart;
var
    n: string;
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, LightRed);
    Bar(a, b*3, a*3, b*7);
    Str(numb, n);
    SetTextStyle(0, 0, 6);
    SetColor(Red);
    OutTextXY(Trunc(2*a-TextWidth(n)/2), Trunc(5*b-TextHeight(n)/2), n);
end;

procedure HideLeftPart;
var
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, LightGreen);
    Bar(a, b*3, a*3, b*7);
end;

procedure DrawRightPart;
var
    n: string;
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, LightRed);
    Bar(a*9, b*3, a*11, b*7);
    Str(numb, n);
    SetTextStyle(0, 0, 6);
    SetColor(Red);
    OutTextXY(Trunc(10*a-TextWidth(n)/2), Trunc(5*b-TextHeight(n)/2), n);
end;

procedure HideRightPart;
var
    a,b: byte;
begin
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, LightGreen);
    Bar(a*9, b*3, a*11, b*7);
end;

procedure MenuLeft;
begin
    if num = 1 then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= 6;
        DrawCentr(num);
        DrawLeftPart(num-1);
        Exit;
    end;
    if num = 2 then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= 1;
        DrawCentr(num);
        DrawRightPart(num+1);
        Exit;
    end;
    if (num <> 1) and (num <> 2) then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= num-1;
        DrawCentr(num);
        DrawLeftPart(num-1);
        DrawRightPart(num+1);
    end;
end;

procedure MenuRight;
begin
    if num = 5 then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= 6;
        DrawCentr(num);
        DrawLeftPart(num-1);
        Exit;
    end;
    if num = 6 then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= 1;
        DrawCentr(num);
        DrawRightPart(num+1);
        Exit;
    end;
    if (num <> 6) and (num <> 5) then
    begin
        HideCentr;
        HideLeftPart;
        HideRightPart;
        num:= num+1;
        DrawCentr(num);
        DrawLeftPart(num-1);
        DrawRightPart(num+1);
    end;
end;

procedure GameExit;
var
    n: string;
    a,b: byte;
    c: char;
begin
    n:= 'You sure? (Y/N)';
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, True);
    SetFillStyle(1, Blue);
    Bar(a*2-8, b*3-8, a*10+8, b*7+8);
    SetFillStyle(1, LightBlue);
    Bar(a*2, b*3, a*10, b*7);
    SetTextStyle(0, 0, 3);
    SetColor(Blue);
    OutTextXY(Trunc(6*a-TextWidth(n)/2), Trunc(5*b-TextHeight(n)/2), n);
    repeat
        if KeyPressed then
        begin
            c:= ReadKey;
            case c of
            'n': StartMenu;
            'y': Fail;
            end;
        end;
        Delay(10);
    until false;
end;
procedure Fail;
begin
    CloseGraph;
   
  
    Halt;
end;

end.
