unit OFIELD;
INTERFACE


uses OLVLDATA, CELLS, CONTROL, GRAPH;
type
    Field = object
    private
        grid: ObjectMatrix;
        procedure SetGrid(n0,m0: byte; i0: byte);
    public
        procedure CreateAndDraw(lvl: LevelData);
        procedure Up(var lvl: LevelData);
        procedure Down(var lvl: LevelData);
        procedure Left(var lvl: LevelData);
        procedure Right(var lvl: LevelData);
        procedure WinWindow;
        procedure LoseWindow;
    end;
IMPLEMENTATION
procedure Field.SetGrid;
var
    e: ^Empty;
    w: ^Wall;
    p: ^Player;
    b: ^Block;
    g: ^Goal;
    bg: ^BlockX;
    pg: ^PlayerX;
begin
    New(grid[n0, m0]);
    grid[n0, m0]^.index:= i0;
    if grid[n0, m0]^.index = 0 then
    begin
        New(grid[n0, m0]^.data);
        e:= grid[n0, m0]^.data;
        e^.SetX(n0);
        e^.SetY(m0);
        e^.Draw;
    end;
    if grid[n0, m0]^.index = 1 then
    begin
        New(grid[n0, m0]^.data);
        w:= grid[n0, m0]^.data;
        w^.SetX(n0);
        w^.SetY(m0);
        w^.Draw;
    end;
    if grid[n0, m0]^.index = 2 then
    begin
        New(grid[n0, m0]^.data);
        p:= grid[n0, m0]^.data;
        p^.SetX(n0);
        p^.SetY(m0);
        p^.Draw;
    end;
    if grid[n0, m0]^.index = 3 then
    begin
        New(grid[n0, m0]^.data);
        b:= grid[n0, m0]^.data;
        b^.SetX(n0);
        b^.SetY(m0);
        b^.Draw;
    end;
    if grid[n0, m0]^.index = 4 then
    begin
        New(grid[n0, m0]^.data);
        g:= grid[n0, m0]^.data;
        g^.SetX(n0);
        g^.SetY(m0);
        g^.Draw;
    end;
    if grid[n0, m0]^.index = 5 then
    begin
        New(grid[n0, m0]^.data);
        bg:= grid[n0, m0]^.data;
        bg^.SetX(n0);
        bg^.SetY(m0);
        bg^.Draw;
    end;
    if grid[n0, m0]^.index = 6 then
    begin
        New(grid[n0, m0]^.data);
        pg:= grid[n0, m0]^.data;
        pg^.SetX(n0);
        pg^.SetY(m0);
        pg^.Draw;
    end;
end;
procedure Field.CreateAndDraw;
var
    n,m: byte;
begin
    SetViewPort(0, 0, GetMaxX, GetMaxY, true);
    SetFillStyle(1, Green);
    Bar(0, 0, GetMaxX, GetMaxY);
    for n:= 1 to lvl.GetSizeX-1 do
        for m:= 1 to lvl.GetSizeY-1 do
            SetGrid(n, m, lvl.GetMap(n, m));
end;
procedure Field.Up;
begin
    OUp(grid, lvl);
end;
procedure Field.Down;
begin
    ODown(grid, lvl);
end;
procedure Field.Left;
begin
    OLeft(grid, lvl);
end;
procedure Field.Right;
begin
    ORight(grid, lvl);
end;
procedure Field.WinWindow;
var
    win: string;
    a,b: byte;
    c: char;
begin
    win:= 'YOU WIN!';
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, True);
    SetFillStyle(1, Blue);
    Bar(a*2-8, b*3-8, a*10+8, b*7+8);
    SetFillStyle(1, LightBlue);
    Bar(a*2, b*3, a*10, b*7);
    SetTextStyle(0, 0, 4);
    SetColor(Blue);
    OutTextXY(Trunc(6*a-TextWidth(win)/2), Trunc(5*b-TextHeight(win)/2), win);
end;
procedure Field.LoseWindow;
var
    win: string;
    a,b: byte;
    c: char;
begin
    win:= 'YOU LOSE';
    a:= GetMaxX div 12;
    b:= GetMaxY div 10;
    SetViewPort(0, 0, GetMaxX, GetMaxY, True);
    SetFillStyle(1, Blue);
    Bar(a*2-8, b*3-8, a*10+8, b*7+8);
    SetFillStyle(1, LightBlue);
    Bar(a*2, b*3, a*10, b*7);
    SetTextStyle(0, 0, 4);
    SetColor(Blue);
    OutTextXY(Trunc(6*a-TextWidth(win)/2), Trunc(5*b-TextHeight(win)/2), win);
end;



end.
