
unit OLVLDATA;
INTERFACE


type
    MapType = array[1..21, 1..16] of byte;
    Decart = record
        x,y: byte;
    end;
    LevelData = object
    private
        f: text;
        way: string;
        map: MapType;
        size: Decart;
        goals: byte;
    public
        position:decart;
        procedure CreateDigitalMap;
        procedure SetWayToFile(way0: string);
        procedure IdentifyPlayer;
        procedure SetPosition(x0,y0: byte);
        procedure CalculateTargets;
        function GetMap(n0,m0: integer): byte;
        function GetSizeX: byte;
        function GetSizeY: byte;
        function GetPositionX: byte;
        function GetPositionY: byte;
        function GetTurgetsNumber: byte;
        procedure SetTurgetsNumber(tn: byte);
    end;

             IMPLEMENTATION


{ Digital Map ------------- }
procedure LevelData.CreateDigitalMap;
var
    n,m,b: byte;
    e: string[21];
    lines: array[0..15] of string;
begin
    size.x:= 0;
    size.y:= 0;
    Assign(f, way);
    {$I-}
    Reset(f);
    {$I+}
    b:= 0;
    repeat
        ReadLn(f, e);
        lines[b]:= e;
        b:= b+1;
    until EOF(f);
    b:= b-1;
    for m:= 0 to b do

    begin
        for n:= 0 to Length(lines[m]) do
        begin
            e:= lines[m];
            case e[n+1] of
            '0': map[n, m]:= 0;
            '1': map[n, m]:= 1;
            '2': map[n, m]:= 2;
            '3': map[n, m]:= 3;
            '4': map[n, m]:= 4;
            '5': map[n, m]:= 5;
            '6': map[n, m]:= 6;
            end;
            if n > size.x then
                size.x:= n;
        end;
        size.y:= size.y+1;
    end;
    Close(f);
end;

{ Way To File ------------- }
procedure LevelData.SetWayToFile;
begin
    way:= way0;
end;

{ Identify Player --------- }
procedure LevelData.IdentifyPlayer;
var
    n,m: byte;
begin
    position.x:= 0;
    position.y:= 0;
        for n:= 0 to size.x do
            for m:= 0 to size.y do
                if map[n, m] = 2 then
                begin
                    position.x:= n;
                    position.y:= m;
                end;
end;

{ Set Position ------------ }
procedure LevelData.SetPosition;
begin
    position.x:= x0;
    position.y:= y0;
end;

{ Calculate Targets ------- }
procedure LevelData.CalculateTargets;
var
    n,m: byte;
begin
    goals:= 0;
        for n:= 0 to size.x do
            for m:= 0 to size.y do
                if map[n, m] = 3 then
                    goals:= goals+1;

end;

{ Get Size X -------------- }
function LevelData.GetSizeX;
begin
    GetSizeX:= size.x;
end;

{ Get Size Y -------------- }
function LevelData.GetSizeY;
begin
    GetSizeY:= size.y;
end;

{ Get Position X ---------- }
function LevelData.GetPositionX;
begin
    GetPositionX:= position.x;
end;

{ Get Position Y ---------- }
function LevelData.GetPositionY;
begin
    GetPositionY:= position.y;
end;

{ Get Map ----------------- }
function LevelData.GetMap;
begin
    GetMap:= map[n0, m0];
end;

{ Get Targets Number ------ }
function LevelData.GetTurgetsNumber;
begin
    GetTurgetsNumber:= goals;
end;

{ Set Targets Number ------ }
procedure LevelData.SetTurgetsNumber;
begin
    goals:= tn;
end;

end.
